using System;
using System.Xml;

//This code is the modified version of the sample code provided in Andrew Connell's book :Professional SharePoint //2007 Web Content Management Development 
//http://www.devhorizon.com/go/112 


namespace WeatherWebPart
{
  internal class WorkerTask {

    private XmlNodeList _taskResults;
    delegate void WorkerTaskDelegate ();
    private WorkerTaskDelegate _task;

    public WorkerTask () {
    }

    public XmlNodeList TaskResults {
      get { return _taskResults; }
    }

    private void ExecuteTask () {
      // fetch RSS feed
      XmlDocument rssFeed = new XmlDocument();
      rssFeed.LoadXml(MsnRss.content);
      // get all items from the feed using an xPath query
      _taskResults = rssFeed.DocumentElement.SelectNodes("channel/item");
    }

    internal IAsyncResult OnBegin (object sender, EventArgs e, AsyncCallback cb, object data) {
      _task = new WorkerTaskDelegate(ExecuteTask);
      return _task.BeginInvoke(cb, data);
    }

    internal void OnEnd (IAsyncResult result) {
      _task.EndInvoke(result);
    }

    internal void OnTimeout (IAsyncResult result) {
      _taskResults = null;
    }
  }
}