﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint;
using System.Configuration;

namespace BlendedConfigMgmnt
{
    public class ConfigSettingLocator
    {
        public const string WebServicesUrlKey = "CRMWsUrl";
        public static string CRMWebServicesUrl
        {
            get
            {
                string crmWebSvcUrl = ConfigurationManager.AppSettings[WebServicesUrlKey];
                if (string.IsNullOrEmpty(crmWebSvcUrl) && SPContext.Current != null)
                {
                    SPWebApplication app = null;
                    if (SPContext.Current != null)
                        app = SPContext.Current.Site.WebApplication;

                    if (app != null && app.Properties.ContainsKey(WebServicesUrlKey))
                        crmWebSvcUrl = (string)app.Properties[WebServicesUrlKey];
                }

                return crmWebSvcUrl;

            }

        }
    }
}
